<%-- $Id: view_plugin.jsp 6640 2014-12-04 08:31:57Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Johan Enell, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.JobAgent"
	import="net.sf.basedb.core.JobAgentSettings"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.RoleKey"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.JarClassLoader"
	import="net.sf.basedb.util.ToStringComparator"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Date"
	import="java.util.Collections"
	import="java.util.List"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.TreeSet"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.PLUGINDEFINITION;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
	
	private static final String getShortPermissions(Item itemType, Set<Permission> granted, Set<Permission> denied)
	{
		Set<Permission> defined = itemType.getDefinedPermissions();
		StringBuilder sb = new StringBuilder();
		if (defined.contains(Permission.CREATE)) sb.append(granted.contains(Permission.CREATE) ? "C" : denied.contains(Permission.CREATE) ? "-" : "c");
		if (defined.contains(Permission.READ)) sb.append(granted.contains(Permission.READ) ? "R" :  denied.contains(Permission.READ) ? "-" : "r");
		if (defined.contains(Permission.USE)) sb.append(granted.contains(Permission.USE) ? "U" :  denied.contains(Permission.USE) ? "-" : "u");
		if (defined.contains(Permission.WRITE)) sb.append(granted.contains(Permission.WRITE) ? "W" :  denied.contains(Permission.WRITE) ? "-" : "w");
		if (defined.contains(Permission.DELETE)) sb.append(granted.contains(Permission.DELETE) ? "D" :  denied.contains(Permission.DELETE) ? "-" : "d");
		if (defined.contains(Permission.SET_OWNER)) sb.append(granted.contains(Permission.SET_OWNER) ? "O" :  denied.contains(Permission.SET_OWNER) ? "-" : "o");
		if (defined.contains(Permission.SET_PERMISSION)) sb.append(granted.contains(Permission.SET_PERMISSION) ? "P" :  denied.contains(Permission.SET_PERMISSION) ? "-" : "p");
		return sb.toString();
	}
%>
<%
final boolean iFrame = Values.getBoolean(request.getParameter("iframe"));
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String tab = Values.getStringOrNull(request.getParameter("tab"));
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	String warning = null;
	PluginDefinition plugin = PluginDefinition.getById(dc, itemId);
	final boolean internal = plugin.getJarFile() == null;
	final boolean loaded = internal || JarClassLoader.exists(plugin.getJarPath());
	final boolean usePermissions = plugin.getUsePermissions();
	final Set<GuiContext> contexts = new TreeSet<GuiContext>(new ToStringComparator<GuiContext>(false));
	contexts.addAll(plugin.getGuiContexts());
	
	final boolean usePermission = plugin.hasPermission(Permission.USE);
	final boolean writePermission = plugin.hasPermission(Permission.WRITE);
	final boolean deletePermission = plugin.hasPermission(Permission.DELETE);
	final boolean sharePermission = plugin.hasPermission(Permission.SET_PERMISSION);
	final boolean setOwnerPermission = plugin.hasPermission(Permission.SET_OWNER);
	final boolean isRemoved = plugin.isRemoved();
	final boolean isUsed = isRemoved && plugin.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	final boolean isOwner = plugin.isOwner();
	
	try
	{
		if (plugin.isDisabled()) 
		{
			warning = "This plugin is disabled";
		}
		else
		{
			plugin.newInstance(Plugin.class, sc, null, null);
		}
	}
	catch (RuntimeException ex)
	{
		warning = ex.getMessage();
	}
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, plugin);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>" type="<%=iFrame ? "iframe" : "default" %>" id="view-page">
	<base:head scripts="tabcontrol-2.js,table.js,~plugins.js" styles="toolbar.css,headertabcontrol.css,path.css,table.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<%
		if (!iFrame)
		{
			%>
			<p:path><p:pathelement 
				title="Plugins" href="<%="index.jsp?ID="+ID%>" 
				/><p:pathelement title="<%=HTML.encodeTags(plugin.getName())%>"
				/></p:path>
			<%
		}
		%>
		<div id="page-data" data-item-id="<%=itemId%>" data-iframe="<%=iFrame ? 1 : 0%>"></div>
		<t:tabcontrol 
			id="main" 
			subclass="content mastertabcontrol" 
			active="<%=tab%>"
			notabs="<%=iFrame%>">
		<t:tab id="properties" title="Properties">
			<div>
			<table class="fullform larger bottomborder">
			<tr>
				<th class="itemstatus">
					<base:icon 
						image="shared.png" 
						visible="<%=plugin.isShared()%>"
						tooltip="This item is shared to other users, groups and/or projects"
					/>
					<base:icon 
						id="btnDeletePermanently"
						image="deleted.png"
						tooltip="This item has been flagged for deletion. Click to delete it now."
						enabled="<%=deletePermanentlyPermission %>"
						visible="<%=isRemoved%>" 
					/>
					<base:icon
						id="btnUsingItems"
						image="used.png" 
						tooltip="This item is used by other items and can't be permanently deleted. Show the items that are using this one"
						visible="<%=isRemoved && isUsed%>" />
				</th>
				<td style="padding: 0px;">
					<tbl:toolbar subclass="bottomborder bg-filled-50">
						<tbl:button 
							id="btnEdit"
							disabled="<%=!writePermission%>" 
							image="edit.png" 
							title="Edit&hellip;" 
							tooltip="<%=writePermission ? "Edit this plugin" : "You do not have permission to edit this plugin"%>" 
						/>
						<tbl:button 
							id="btnToggleDisabled"
							image="plugin.png"
							data-enable="<%=plugin.isDisabled() ? 1 : 0%>" 
							data-plugin-class="<%=plugin.getClassName() %>"
							title="<%=plugin.isDisabled() ? "Enable" : "Disable"%>"
							visible="<%=writePermission%>"
							tooltip="Disable/enable this plugin" 
						/>
						<tbl:button 
							id="btnDelete"
							data-extra-url="<%="&iframe="+iFrame%>"
							disabled="<%=!deletePermission%>" 
							image="delete.png" 
							title="Delete"
							visible="<%=!plugin.isRemoved()%>"
							tooltip="<%=deletePermission ? "Delete this plugin" : "You do not have permission to delete this plugin"%>" 
						/>
						<tbl:button 
							id="btnRestore"
							data-extra-url="<%="&iframe="+iFrame%>"
							disabled="<%=!writePermission%>" 
							image="restore.png" 
							title="Restore"
							visible="<%=plugin.isRemoved()%>"
							tooltip="<%=writePermission ? "Restore this plugin" : "You do not have permission to restore this plugin"%>" 
						/>
						<tbl:button 
							id="btnShare"
							disabled="<%=!sharePermission%>"
							image="share.png"
							title="Share&hellip;" 
							tooltip="<%=sharePermission ? "Share this plugin to other user, groups and projects" : "You do not have permission to share this plugin"%>"
						/>
						<tbl:button 
							id="btnSetOwner"
							disabled="<%=!setOwnerPermission%>"
							image="take_ownership.png"
							title="Set owner&hellip;"
							tooltip="<%=setOwnerPermission ? "Change owner of this item" : "You do not have permission to change ownership of this item"%>"
						/>
						<tbl:button
							id="btnNewConfiguration"
							image="add.png"
							title="New configuration&hellip;"
							tooltip="Create a new configuration for this plugin"
							visible="<%=sc.hasPermission(Permission.CREATE, Item.PLUGINCONFIGURATION) && 
								usePermission && plugin.supportsConfigurations()%>"
						/>
						<tbl:button 
							id="btnImport"
							image="import.png" 
							data-plugin-type="IMPORT"  
							title="Import&hellip;" 
							tooltip="Import data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
						/>
						<tbl:button 
							id="btnExport"
							image="export.png"
							data-plugin-type="EXPORT" 
							title="Export&hellip;" 
							tooltip="Export data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
						/>
						<tbl:button 
							id="btnRunPlugin"
							image="runplugin.png"  
							data-plugin-type="OTHER" 
							title="Run plugin&hellip;" 
							tooltip="Run a plugin" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
						/>
						<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
							wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
						<tbl:button
							image="help.png"
							subclass="auto-init"
							data-auto-init="help"
							data-help-id="plugindefinition.view.properties"
							title="Help&hellip;"
							tooltip="Get help about this page"
						/>
					</tbl:toolbar>
				</td>
			</tr>
			<tr>
				<th>Name</th>
				<td><%=HTML.encodeTags(plugin.getName())%></td>
			</tr>
			<tr>
				<th>Registered</th>
				<td><%=dateFormatter.format(plugin.getEntryDate())%></td>
			</tr>
			<tr>
				<th>Type</th>
				<td><%=plugin.getMainType()%></td>
			</tr>
			<tr>
				<th>Class</th>
				<td><%=plugin.getClassName()%></td>
			</tr>
			<tr>
				<th>JAR file</th>
				<td><%=internal ? "<i>- internal -</i>" : plugin.getJarFile()%></td>
			</tr>
			<tr>
				<th>Version</th>
				<td><%=plugin.getVersionString()%></td>
			</tr>
			<tr>
				<th>Max memory</th>
				<td><%=Values.formatBytes(plugin.getMaxMemory())%></td>
			</tr>
			<tr>
				<th>Trusted</th>
				<td><%=plugin.isTrusted() ? "yes" : "no"%></td>
			</tr>			
			<tr>
				<th>Allow immediate execution</th>
				<td><%=plugin.getAllowImmediateExecution() ? "yes" : "no"%></td>
			</tr>			
			<tr>
				<th>Use internal job queue</th>
				<td><%=plugin.getUseInternalJobQueue() ? "yes" : "no"%></td>
			</tr>			
			<tr>
				<th>Items</th>
				<td><%=Values.getString(contexts, ", ", true)%></td>
			</tr>
			<tr>
				<th>Contact</th>
				<td><%=HTML.encodeTags(plugin.getContact())%></td>
			</tr>
			<tr>
				<th>Copyright</th>
				<td><%=HTML.encodeTags(plugin.getCopyright())%></td>
			</tr>
			<tr>
				<th>Email</th>
				<td><%=HTML.scanForLinks(plugin.getEmail(), HTML.LINK_EMAIL, "_blank")%></td>
			</tr>
			<tr>
				<th>Url</th>
				<td><%=HTML.scanForLinks(plugin.getUrl(), HTML.LINK_URL, "_blank")%></td>
			</tr>
			<tr>
				<th>Owner</th>
				<td><base:propertyvalue item="<%=plugin%>" property="owner" /></td>
			</tr>
			<tr>
				<th>Permissions</th>
				<td><%=PermissionUtil.getFullPermissionNames(plugin)%></td>
			</tr>
			<tr class="big">
				<th>Description</th>
				<td><%=HTML.niceFormat(plugin.getDescription())%></td>
			</tr>
			</table>
			</div>

			<%
			if (warning != null)
			{
				%>
				<div class="messagecontainer error"><%=warning%></div>
				<%
			}
			%>

			<%
			if (plugin.supportsConfigurations())
			{
				ItemQuery<PluginConfiguration> configQuery = plugin.getPluginConfigurations();
				configQuery.include(Include.ALL);
				configQuery.order(Orders.asc(Hql.property("name")));
				ItemResultList<PluginConfiguration> configurations = configQuery.list(dc);
				%>
				<base:section
					id="configurations"
					title="<%="Configurations (" + configurations.size() + ")" %>"
					context="<%=cc%>"
					>
					<%
					if (configurations.size() == 0)
					{
						%>
						<div class="messagecontainer note">
						There are no configurations for this plugin (or, you don't have permission to view them).
						</div>
						<%
					}
					else
					{
						%>
						<tbl:table
							id="tbl.configurations"
							columns="all"
							>
						<tbl:columndef 
							id="name"
							title="Name"
						/>
						<tbl:columndef 
							id="description"
							title="Description"
						/>
						<tbl:columndef
							id="configure"
							title="Configure"
							show="<%=plugin.supportsConfigurations() ? "always" : "never" %>"
						/>
						<tbl:data>
							<tbl:headers>
								<tbl:headerrow>
									<tbl:columnheaders />
								</tbl:headerrow>
							</tbl:headers>
							<tbl:rows>
							<%
							for (PluginConfiguration pc : configurations)
							{
								%>
								<tbl:row>
									<tbl:cell column="name"><base:icon 
											image="deleted.png" 
											tooltip="This item has been scheduled for deletion" 
											visible="<%=pc.isRemoved()%>"
										/><%=Base.getLinkedName(ID, pc, false, true)%></tbl:cell>
									<tbl:cell column="description"><%=HTML.niceFormat(pc.getDescription())%></tbl:cell>
									<tbl:cell column="configure">
									<%
									if (pc.hasPermission(Permission.WRITE))
									{
										%>
										<base:icon
											id="<%="configure-plugin."+pc.getId()%>"
											subclass="auto-init"
											data-auto-init="configure-plugin"
											data-item-id="<%=pc.getId()%>"
											image="runplugin.png" 
											tooltip="Configure this plugin "/>
										<%
									}
									%>
									</tbl:cell>
								</tbl:row>
								<%
							}
							%>
							</tbl:rows>
						</tbl:data>
						</tbl:table>
					<%
				}
				%>
				</base:section>
				<%
			}
			%>
			<%
			ItemQuery<JobAgent> agentQuery = JobAgent.getQuery();
			agentQuery.include(Include.ALL);
			agentQuery.order(Orders.asc(Hql.property("name")));
			agentQuery.join(Hql.innerJoin("plugins", "p"));
			agentQuery.restrict(Restrictions.eq(Hql.property("p", "pluginDefinition"), Hql.entity(plugin)));
			ItemResultList<JobAgent> agents = agentQuery.list(dc);
			%>
			<base:section
				id="jobagents"
				title="<%="Installed on job agents (" + agents.size() + ")" %>"
				context="<%=cc%>"
				>
				<%
				if (agents.size() == 0)
				{
					%>
					<div class="messagecontainer note">
					This plugin isn't installed on any job agents (or, you don't have permission to view them).
					</div>
					<%
				}
				else
				{
					%>
					<tbl:table
						id="agents"
						columns="all"
						>
					<tbl:columndef 
						id="name"
						title="Name"
					/>
					<tbl:columndef 
						id="server"
						title="Server"
					/>
					<tbl:columndef 
						id="info"
						title="CPU/Memory"
					/>
					<tbl:columndef
						id="maxMemory"
						title="Max memory"
					/>
					<tbl:columndef
						id="trusted"
						title="Trusted"
					/>
					<tbl:columndef
						id="priorityBoost"
						title="Priority boost"
					/>
					<tbl:columndef
						id="configure"
						title=""
					/>
					<tbl:data>
						<tbl:headers>
							<tbl:headerrow>
								<tbl:columnheaders />
							</tbl:headerrow>
						</tbl:headers>
						<tbl:rows>
						<%
						for (JobAgent agent : agents)
						{
							String server = agent.getServer();
							Integer port = agent.getPort();
							JobAgentSettings settings = agent.getSettings(plugin, false);
							Long maxMemory = settings.getEffectiveMaxMemory();
							%>
							<tbl:row>
								<tbl:cell column="name"><base:icon 
										image="deleted.png" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=agent.isRemoved()%>"
									/><%=Base.getLinkedName(ID, agent, false, true)%></tbl:cell>
								<tbl:cell column="server"><%=server == null || port == null ? "" : server + ":" + port%></tbl:cell>
								<tbl:cell column="info">
									CPU usage: <%=agent.getCpuUsage() == null ? "<i>- unknown -</i>" : agent.getCpuUsage()+"%" %><br>
									Total memory: <%=agent.getTotalMemory() == null ? "<i>- unknown -</i>" : Values.formatBytes(agent.getTotalMemory()) %><br>
									Used memory: <%=agent.getUsedMemory() == null ? "<i>- unknown -</i>" : Values.formatBytes(agent.getUsedMemory()) %>
								</tbl:cell>
								<tbl:cell column="maxMemory"><%=maxMemory == null ? "<i>- not specified -</i>" : Values.formatBytes(maxMemory)%></tbl:cell>
								<tbl:cell column="trusted"><%=settings.isEffectivelyTrusted()%></tbl:cell>
								<tbl:cell column="priorityBoost"><%=settings.getPriorityBoost()%></tbl:cell>
								<tbl:cell column="configure">
								<%
								if (agent.hasPermission(Permission.WRITE))
								{
									%>
									<base:icon 
										id="<%="configure-agent."+agent.getId()%>"
										subclass="auto-init"
										data-auto-init="configure-agent"
										data-item-id="<%=agent.getId()%>"
										image="runplugin.png" 
										tooltip="Configure the settings for this plugin on the job agent "/>
									<%
								}
								%>
								</tbl:cell>
							</tbl:row>
							<%
						}
						%>
						</tbl:rows>
					</tbl:data>
					</tbl:table>
					<%
				}
				%>
			</base:section>
			<base:section
				id="permissions"
				title="<%="Permissions (using permissions: " + (usePermissions ? "yes" : "no") + ")" %>"
				context="<%=cc%>"
				>
				<table class="fullform fullborder">
					<tbody class="sectionheader">
						<tr>
						<%
						Map<String, List<Item>> permissionGroups = PermissionUtil.getPermissionGroups();
						for (String name : permissionGroups.keySet())
						{
							%>
							<th class="columnheader" colspan="2"><b><%=name%></b></th>
							<%
						}
						%>
						</tr>
					</tbody>
					<%
					int newItems = 0;
					int rowIndex = 0;
					do
					{
						newItems = 0;
						int colIndex = 0;
						StringBuilder sb = new StringBuilder();
						sb.append("<tr>");
						for (String name : permissionGroups.keySet())
						{
							List<Item> items = permissionGroups.get(name);
							if (items.size() > rowIndex)
							{
								newItems++;
								Item item = items.get(rowIndex);
								int keyId = SystemItems.getRoleKeyId(item);
								RoleKey key = RoleKey.getById(dc, keyId);
								
								sb.append("<th");
								if (colIndex > 0) sb.append(" class=\"leftborder\"");
								sb.append(">").append(key.getName()).append("</th>");
								sb.append("<td>");
								
								if (keyId != 0)
								{								
									Set<Permission> granted = plugin.getGranted(key);
									Set<Permission> denied = plugin.getDenied(key);
									sb.append(getShortPermissions(item, granted, denied));
								}
								else
								{
									sb.append("(undefined key)");
								}
								sb.append("</td>");
							}
							else
							{
								sb.append("<th class=\"subprompt");
								if (colIndex > 0) sb.append(" leftborder");
								sb.append("\"></th><td></td>");
							}
							colIndex++;
						}
						if (newItems > 0)
						{
							%>
							<%=sb.toString()%>
							<%
						}
						rowIndex++;
					} while (newItems > 0);
					%>
				</table>
				Capital letters = Permission is always granted, Small letters = Permission is only granted if logged in user 
				has that permission<br>
				<b>C/c</b> = Create, <b>R/r</b> = Read, <b>U/u</b> = Use, 
				<b>W/w</b> = Write, <b>D/d</b> = Delete, <b>O/o</b> = Change owner, 
				<b>P/p</b> = Change permissions

			</base:section>
			<jsp:include page="../../common/anytoany/list_anytoany.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Other items related to this plugin" />
			</jsp:include>
			<jsp:include page="../../common/share/list_share.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Shared to" />
			</jsp:include>
		</t:tab>
		<t:tab id="annotations" title="Annotations" 
			tooltip="View annotation values" clazz="white"
			visible="<%=!plugin.requiresConfiguration() && plugin.supports("net.sf.basedb.core.plugin.AnnotationSetterPlugin") %>">
			<jsp:include page="../../common/annotations/list_frameset.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
		</t:tab>			
		</t:tabcontrol>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
