<%-- $Id: view_bioassayset.jsp 6988 2015-10-30 09:31:37Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Johan Enell

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.BioAssay"
	import="net.sf.basedb.core.Transformation"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.ParameterInfo"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.clients.web.extensions.plot.OverviewPlotAction"
	import="net.sf.basedb.clients.web.extensions.plot.PlotGenerator"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.extensions.ActionIterator"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
	import="java.util.Iterator"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.BIOASSAYSET;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String tabId = Values.getString(request.getParameter("tab"), "properties");

final float scale = Base.getScale(sc);
final String root = request.getContextPath();
final DbControl dc = sc.newDbControl();
try
{
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	final BioAssaySet bioAssaySet = BioAssaySet.getById(dc, itemId);
	final Experiment experiment = bioAssaySet.getExperiment();
	final int experimentId = experiment.getId();
	final boolean hasDbSpots = bioAssaySet.getNumSpots() > 0;
	Transformation transformation = bioAssaySet.getTransformation();
	RawDataType rawDataType = experiment.getRawDataType();
	
	Job job = null;
	boolean readJob = true;
	PluginDefinition plugin = null;
	boolean readPlugin = true;
	PluginConfiguration configuration = null;
	boolean readConfiguration = true;

	try
	{
		job = transformation.getJob();
	}
	catch (PermissionDeniedException ex)
	{
		readJob = false;
		readPlugin = false;
		readConfiguration = false;
	}
	if (job != null)
	{
		try
		{
			plugin = job.getPluginDefinition();
		}
		catch (PermissionDeniedException ex)
		{
			readPlugin = false;
		}
		try
		{
			configuration = job.getPluginConfiguration();
		}
		catch (PermissionDeniedException ex)
		{
			readConfiguration = false;
		}
	}
	
	final boolean createPermission = experiment.hasPermission(Permission.USE);
	final boolean writePermission = bioAssaySet.hasPermission(Permission.WRITE);
	final boolean deletePermission = bioAssaySet.hasPermission(Permission.DELETE);
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, bioAssaySet);
	ExtensionsInvoker toolbarInvoker = ToolbarUtil.useExtensions(jspContext);
	ExtensionsInvoker overviewPlotInvoker = ExtensionsControl.useExtensions(jspContext, 
			"net.sf.basedb.clients.web.bioassayset.overviewplots");
	%>
	<base:page title="<%=title%>" id="view-page">
	<base:head scripts="table.js,tabcontrol-2.js,~bioassaysets.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css,joust-2.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<style>
		.plot 
		{
			margin: 0.5em;
		}
		.plot.empty
		{
			background-image: url('../../../images/plot_empty_400x300.png');
		}
		</style>
	</base:head>
	<base:body>
		<p:path><p:pathelement 
			title="Experiments" href="<%="../index.jsp?ID="+ID%>" 
			/><p:pathelement title="<%=HTML.encodeTags(experiment.getName())%>" 
				href="<%="index.jsp?ID="+ID+"&amp;experiment_id="+experimentId%>" 
			/><p:pathelement title="<%=HTML.encodeTags(bioAssaySet.getName())%>" 
			/></p:path>
			
		<div id="page-data" 
			data-item-id="<%=itemId%>"
			data-experiment-id="<%=experimentId%>"
		></div>
		
		<t:tabcontrol 
			id="view" 
			subclass="content mastertabcontrol"
			active="<%=tabId%>" remember="false">
		<t:tab id="properties" title="Properties">
			<div>
			<table class="fullform">
			<tr>
				<th class="itemstatus">
					<base:icon 
						id="btnDeletePermanently"
						image="deleted.png"
						tooltip="This item has been flagged for deletion. Click to delete it now."
						enabled="<%=deletePermission %>"
						visible="<%=bioAssaySet.isRemoved()%>" 
					/>
				</th>
				<td style="padding: 0px;">
					<tbl:toolbar subclass="bottomborder bg-filled-50">
						<tbl:button 
							id="btnEdit"
							disabled="<%=!writePermission%>" 
							image="edit.png" 
							title="Edit&hellip;" 
							tooltip="<%=writePermission ? "Edit this bioassay set" : "You do not have permission to edit this bioassay set"%>" 
						/>
						<tbl:button 
							id="btnDelete"
							disabled="<%=!deletePermission%>" 
							image="delete.png" 
							title="Delete"
							visible="<%=!bioAssaySet.isRemoved()%>"
							tooltip="<%=deletePermission ? "Delete this bioassay set" : "You do not have permission to delete this bioassay set"%>" 
						/>
						<tbl:button 
							id="btnRestore"
							disabled="<%=!writePermission%>" 
							image="restore.png" 
							title="Restore"
							visible="<%=bioAssaySet.isRemoved()%>"
							tooltip="<%=writePermission ? "Restore this bioassay set" : "You do not have permission to restore this bioassay set"%>" 
						/>
						<tbl:button 
							id="btnImport"
							image="import.png" 
							data-plugin-type="IMPORT"  
							title="Import&hellip;" 
							tooltip="Import data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
						/>
						<tbl:button 
							id="btnExport"
							image="export.png"
							data-plugin-type="EXPORT" 
							title="Export&hellip;" 
							tooltip="Export data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
						/>
						<tbl:button
							id="btnPlot"
							image="plotter.png"
							title="Plot tool&hellip;"
							tooltip="A simple tool for generating plots"
							visible="<%=hasDbSpots%>"
						/>
						<tbl:button
							id="btnExperimentExplorer"
							image="explorer.png"
							title="Experiment explorer"
							tooltip="View the data reporter by reporter"
							visible="<%=hasDbSpots%>"
						/>
						<tbl:button
							id="btnFilter"
							data-plugin-type="ANALYZE"
							data-cmd="NewFilteredBioAssaySet"
							disabled="<%=!createPermission%>"
							image="filter.png"
							title="Filter bioassay set&hellip;"
							tooltip="<%=createPermission ? 
								"Create a new bioassay set by filtering this bioassayset" :
								"You do not have permission analyze this experiment"%>"
							visible="<%=pluginCount.containsKey(Plugin.MainType.ANALYZE)%>"
			 			/>
						<tbl:button 
							id="btnRunPlugin"
							image="runplugin.png"  
							data-plugin-type="OTHER" 
							title="Run plugin&hellip;" 
							tooltip="Run a plugin" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
						/>
						<tbl:button 
							id="btnAnalyze"
							data-plugin-type="ANALYZE"
							disabled="<%=!createPermission%>"
							image="runplugin.png" 
							title="Run analysis&hellip;" 
							tooltip="<%=createPermission ? "Run an analysis plugin" : 
								"You do not have permission to analyze this experiment"%>"
							visible="<%=pluginCount.containsKey(Plugin.MainType.ANALYZE)%>"
						/>
						<ext:render extensions="<%=toolbarInvoker%>" context="<%=jspContext%>" 
							wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
						<tbl:button
							image="help.png"
							subclass="auto-init"
							data-auto-init="help"
							data-help-id="bioassayset.view.properties"
							title="Help&hellip;"
							tooltip="Get help about this page"
						/>
					</tbl:toolbar>
				</td>
			</tr>
		</table>
		<table style="width: 100%; height: 22em;" class="bottomborder">
		<tr>
			<td style="width: 50%; height: 100%;">
			<table class="fullform" >
			<tr>
				<th>Name</th>
				<td><%=HTML.encodeTags(bioAssaySet.getName())%></td>
			</tr>
			<tr>
				<th>Experiment</th>
				<td><%=Base.getLinkedName(ID, experiment, false, writePermission)%>
				(<%=experiment.getRawDataType()%>)</td>
			</tr>
			<tr>
				<th>Intensity transformation</th>
				<td><%=bioAssaySet.getIntensityTransform().toString()%></td>
			</tr>
			<tr>
				<th>Spots</th>
				<td>db: <%=bioAssaySet.getNumSpots()%>; file: <%=bioAssaySet.getNumFileSpots()%></td>
			</tr>
			<tr>
				<th>Reporters</th>
				<td>db: <%=bioAssaySet.getNumReporters()%>; file: <%=bioAssaySet.getNumFileReporters()%></td>
			</tr>
			<tr>
				<th>Permissions</th>
				<td><%=PermissionUtil.getFullPermissionNames(bioAssaySet)%></td>
			</tr>
			<tr>
				<th>Description</th>
				<td><%=HTML.niceFormat(bioAssaySet.getDescription())%></td>
			</tr>
			<tr>
				<th>Transformation</th>
				<td><%=Base.getLinkedName(ID, transformation, false, 
						transformation.hasPermission(Permission.WRITE))%></td>
			</tr>
			<tr>
				<th>Job</th>
				<td><%=Base.getLinkedName(ID, job, !readJob, false)%></td>
			</tr>
			<tr >
				<th class="subprompt">- started</th>
				<td>
					<%=job == null ? "" : dateTimeFormatter.format(job.getStarted())%>
				</td>
			</tr>
			<tr>
				<th class="subprompt">- ended</th>
				<td>
					<%=job == null ? "" : dateTimeFormatter.format(job.getEnded())%>
				</td>
			</tr>
			<tr>
				<th class="subprompt">- server</th>
				<td>
					<%=job == null ? "" : HTML.encodeTags(job.getServer())%>
				</td>
			</tr>
			<tr class="dynamic">
				<th class="subprompt">- description</th>
				<td><%=HTML.niceFormat(transformation.getDescription())%></td>
			</tr>
			</table>
		</td>
		<td style="width: 50%; height: 100%;" class="leftborder">
			<table class="fullform" >
			<tr>
				<th>Plugin</th>
				<td><%=Base.getLinkedName(ID, plugin, 
						!readPlugin, plugin != null && plugin.hasPermission(Permission.WRITE))%></td>
			</tr>
			<tr>
				<th>Plugin configuration</th>
				<td><%=Base.getLinkedName(ID, configuration, !readConfiguration, 
					configuration != null && configuration.hasPermission(Permission.WRITE))%></td>
			</tr>
			<tbody class="sectionheader">
				<tr>
					<th colspan="2">Plugin parameters</th>
				</tr>
			</tbody>
				<%
				if (job != null)
				{
					for (String name : job.getParameterNames())
					{
						StringBuilder sb = new StringBuilder();
						String displayValue = "";
						String description = "";
						try
						{
							ParameterInfo pi = job.getParameterInfo(name);
							if (pi.getLabel() != null) name = HTML.encodeTags(pi.getLabel());
							description = HTML.encodeTags(pi.getDescription());
							List<?> values = pi.getValuesOrMask();
							int i = 0;
							for (Object value : values)
							{
								if (value != null)
								{
									if (i > 0) sb.append(", ");
									i++;
									if (value instanceof BasicItem)
									{
										BasicItem item = (BasicItem)value;
										String itemName = "";
										if (item instanceof File)
										{
											itemName = ((File)item).getPath().toString();
										}
										else if (item instanceof Nameable)
										{
											itemName = ((Nameable)item).getName();
										}
										else
										{
											itemName = item.toString();
										}
										sb.append(Base.getLink(ID, HTML.encodeTags(itemName), 
											item.getType(), item.getId(), item.hasPermission(Permission.WRITE)));
									}
									else if (value instanceof Date)
									{
										sb.append(dateFormatter.format((Date)value));
									}
									else
									{
										sb.append(HTML.encodeTags(value.toString()));
									}
								}
							}
							displayValue = sb.toString();
						}
						catch (Throwable ex)
						{
							displayValue = "<i>ERROR: "+ex.getMessage()+"</i>";
						}
						%>
						<tr>
						<th class="subprompt"><span title="<%=description%>">- <%=name%></span></th>
							<td>
								<%=displayValue%>
							</td>
						</tr>
						<%
					}
				}
				%>
				<tr class="dynamic">
					<th></th>
					<td></td>
				</tr>
				</table>

			</td>
			</tr>
			</table>
			</div>
			<jsp:include page="../../../common/datafiles/list_files.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
			
			<jsp:include page="../../../common/anytoany/list_anytoany.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Other items related to this bioassay set" />
			</jsp:include>
			
			<base:section id="anaysis" title="Analysis subtree" context="<%=cc%>">
				<jsp:include page="analysis_tree.jsp">
					<jsp:param name="ID" value="<%=ID%>" />
					<jsp:param name="experiment_id" value="<%=experimentId%>" />
					<jsp:param name="item_id" value="<%=itemId%>" />
				</jsp:include>
			</base:section>
			</t:tab>
			
			<t:tab id="annotations" title="Annotations" 
				tooltip="View annotation values" clazz="white">
				<jsp:include page="../../../common/annotations/list_frameset.jsp">
					<jsp:param name="item_type" value="<%=itemType.name()%>" />
					<jsp:param name="item_id" value="<%=itemId%>" />
					<jsp:param name="ID" value="<%=ID%>" />
				</jsp:include>
			</t:tab>
			
			<t:tab id="bioassays" title="Bioassays" />
			
			<t:tab id="spotdata" title="Spot data" visible="<%=hasDbSpots%>">
				<div class="bg-filled-50 absolutefull">
					<table style="margin: auto; height: 100%;"><tr><td>
					<b>Please wait. The spot data is loading...</b>
					</td></tr></table>
				</div>
			</t:tab>
			
			<t:tab id="overviewplots" title="Overview plots" 
				tooltip="Predefined plots for all bioassays in this bioassay set"
				visible="<%=overviewPlotInvoker.getNumExtensions() > 0%>" clazz="white">
				<%
				if ("overviewplots".equals(tabId))
				{
					ActionIterator<OverviewPlotAction> plots = overviewPlotInvoker.iterate();
					%>
					<t:tabcontrol id="overviewplots" style="padding-top: 1em; border: 0px;">
					<% 
					while (plots.hasNext())
					{
						OverviewPlotAction action = plots.next();
						String baseId = plots.getExtension().getId() + "." + action.getId();
						%>
						<t:tab 
							tooltip="<%=action.getDescription() %>"
							title="<%=action.getTitle()%>"
							id="<%=baseId%>"
							clazz="white"
							>
							<%
							for (PlotGenerator generator : action.getPlotGenerators())
							{
								String plotId = generator.getId();
								%><img 
									id="<%=baseId + "." + plotId%>"
									class="plot empty"
									data-plot-group="<%=baseId%>"
									data-plot-url="<%=HTML.encodeTags(generator.getUrl()) %>"
									src="../../../images/transparent_pixel.gif"
									width="<%=generator.getWidth()%>"
									height="<%=generator.getHeight()%>"
									alt="<%=HTML.encodeTags(generator.getTitle())%>"
								>&#8203;&#8203;<%
							}
							%>
						</t:tab>
						<%
					}
					%>
					</t:tabcontrol>
					<%
				}
				%>
			</t:tab>
			</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
